import threading
import os
import time
import numpy as np

class autoExp:
	def __init__(self):
		self.read_lock = threading.Lock()
		self.started = False
		self.exposure = 20
		self.meanSp = 100
		self.frame = np.zeros((128,128))
	
	def start(self):
		if self.started:
			print('[!] Auto exposure thread already started')
			return None
		self.started = True
		self.thread = threading.Thread(target=self.update, args=())
		self.thread.start()
		return self

	def update(self):
		while self.started:
			self.start = time.time()
			self.mean = np.mean(self.frame)

			if self.mean > self.meanSp+20:
				if self.exposure < 10 and self.exposure > 0:
					self.exposure -=1
				elif self.exposure > 0:
					self.exposure -= 2
				self.cmd = "v4l2-ctl -c exposure_absolute=" + str(self.exposure)
				os.system(self.cmd)
			elif self.mean < self.meanSp-20:
				if self.exposure < 10 and self.exposure > 0:
					self.exposure += 1
				elif self.exposure > 0:
					self.exposure += 2
				self.cmd = "v4l2-ctl -c exposure_absolute=" + str(self.exposure)
				os.system(self.cmd)
		    
			time.sleep(0.5-(time.time()-self.start))  			
			
	#def read(self):
		#return self.exit, self.color, self.map, self.turbo

	def stop(self):
		self.started = False
		self.thread.join()

	#def __exit__(self, exec_type, exc_value, traceback):
		#self.close()