import sys
import numpy as np
from scipy import ndimage
import matplotlib.pyplot as plt
import matplotlib.image as mpimg


if len(sys.argv) == 1:
	print("Please specify the folder to draw data from. ")
	exit()
else: 
	fname = sys.argv[2]


pxPerMeter = 200/10


odoData = np.genfromtxt('logs/log ' + fname + '/odo.log', delimiter=',')
odoData = odoData[1:,:]
odoData = (odoData - odoData[1,:])*pxPerMeter

gpsData = np.genfromtxt('logs/log ' + fname + '/gps.log', delimiter=',')
gpsData = gpsData[1:,:]
gpsData = gpsData - gpsData[1,:]
gpsData = np.deg2rad(gpsData[:,:2])*6373000

print(gpsData)

img = mpimg.imread('maps/hairpin_map.jpg')


plt.figure(1)
#plt.imshow(ndimage.rotate(img, -8))
plt.scatter(odoData[:,0],odoData[:,1],color='g')
plt.axis('equal')
plt.axis('off')
#plt.show()

plt.savefig('maps/' + fname + '_odo.png',transparent=True)


plt.figure(2)
plt.scatter(gpsData[:,0],gpsData[:,1],color='r')
plt.axis('equal')
plt.axis('off')
#plt.show()

plt.savefig('maps/' + fname + '_gps.png',transparent=True)
#print(odoData)
#print(gpsData)