import threading
import inputs


class gamepad:
	def __init__(self):
		self.pad = inputs.devices.gamepads
		self.exit = False
		self.color = True
		self.map = False
		self.turbo = False
		self.saveImage = False
		self.log = False
		if len(self.pad) == 0:
			raise Exception("Could not find any game pad.")
		self.read_lock = threading.Lock()
		self.started = False
	
	def start(self):
		if self.started:
			print('[!] Gamepad thread already started')
			return None
		self.started = True
		self.thread = threading.Thread(target=self.update, args=())
		self.thread.start()
		return self

	def update(self):
		while self.started:
			if not self.exit:
				self.events = inputs.get_gamepad()
				
				for event in self.events:
					if event.ev_type == 'Key':
						if event.code == 'BTN_EAST':
							if event.state:
								self.exit = not self.exit
						elif event.code == 'BTN_WEST':
							if event.state:
								self.map = not self.map
						elif event.code == 'BTN_SOUTH':
							if event.state:
								self.turbo = not self.turbo
						elif event.code == 'BTN_MODE':
							if event.state:
								self.color = not self.color
						elif event.code == 'BTN_TR':
							if event.state: 
								self.saveImage = True
						elif event.code == 'BTN_TL':
							if event.state: 
								self.log = not self.log

	def stop(self):
		self.started = False
		self.thread.join()