import numpy as np 
import cv2 as cv 
from gps import mapDist

data = np.genfromtxt('logs/gps_global_2018-12-12_09:58:49.log',delimiter=',')

dtuMap = cv.imread("DTU_map.png",1)
mapWidth = 1.33
mapHeight = 1.65

distXOld, distYOld = 0,0

for lat,lon,fix,man in data:
	distX, distY = mapDist(lat,lon)

	if distXOld != 0:
		if man == 1:
			cv.line(dtuMap,(int((distXOld/mapWidth)*dtuMap.shape[1]),int((abs(distYOld)/mapHeight)*628)),(int((distX/mapWidth)*dtuMap.shape[1]),int((abs(distY)/mapHeight)*628)),(0,0,255),2)
		else:
			cv.line(dtuMap,(int((distXOld/mapWidth)*dtuMap.shape[1]),int((abs(distYOld)/mapHeight)*628)),(int((distX/mapWidth)*dtuMap.shape[1]),int((abs(distY)/mapHeight)*628)),(255,215,0),2)

	distXOld = distX
	distYOld = distY 

cv.namedWindow('Map',cv.WINDOW_NORMAL)
cv.resizeWindow('Map',700,700)
cv.imshow('Map',dtuMap)

cv.waitKey(0)

cv.destroyAllWindows()