import keras
import mxnet as mx
from keras.models import Model
from keras.models import load_model
from keras.applications.vgg16 import preprocess_input
from losses import bceDiceLoss, diceCoeff
import numpy as np
import cv2 as cv
import math
from collections import namedtuple
Batch = namedtuple('Batch', ['data'])


def loadModel(modelName):

	return load_model(modelName,custom_objects={'bce_dice_loss':bceDiceLoss,'dice_coeff':diceCoeff})

def forwardPass(img, model):

	img = preprocess_input(img)
	img = (1./255)*img
	img = np.expand_dims(img, axis=0)

	mask = model.predict(img)
	mask = np.squeeze(mask)

	mask[mask > 0.5] = 255
	mask[mask < 0.5] = 0

	return mask

def loadModelMx(modelName):
	sym, arg_params, aux_params = mx.model.load_checkpoint(prefix=modelName, epoch=0)
	mod = mx.mod.Module(symbol=sym, data_names=['/input_11'], context=mx.cpu(), label_names=None)

	mod.bind(for_training=False, data_shapes=[('/input_11', (1,3,128,128))], label_shapes=mod._label_shapes)

	mod.set_params(arg_params, aux_params, allow_missing=True)

	return mod

def forwardPassMx(img,model):

	img = preprocess_input(img)
	img = (1./255)*img
	img = np.expand_dims(img, axis=0)
	img = np.rollaxis(img, 3, 1)  
	img = mx.nd.array(img)
	model.forward(Batch([img]))
	mask = model.get_outputs()[0].asnumpy()
	#img = np.rollaxis(img, 1, 3)  
	mask = np.squeeze(mask)

	mask[mask > 0.5] = 255
	mask[mask < 0.5] = 0

	return mask
	