import numpy as np
import cv2 as cv
import time
import datetime
import sys
import os


os.system("v4l2-ctl -c focus_auto=0")
os.system("v4l2-ctl -c focus_absolute=0")
os.system("v4l2-ctl -c exposure_auto_priority=0")
os.system("v4l2-ctl -c exposure_auto=1")
os.system("v4l2-ctl -c exposure_absolute=125")

exposure = 125
meanSp = 100


vidName = datetime.datetime.fromtimestamp(time.time()).strftime('%Y-%m-%d-%H_%M_%S_%f') + '.avi'

cap = cv.VideoCapture(0)
fourcc = cv.VideoWriter_fourcc(*'XVID')
out = cv.VideoWriter(vidName,fourcc,24.0,(640,480))

cv.namedWindow('Frame',cv.WINDOW_NORMAL)
cv.resizeWindow('Frame',700,700)


while(cap.isOpened()):

	start = time.time()

	ret, frame = cap.read()
	#frame = cv.resize(frame,(128,128),interpolation = cv.INTER_AREA)


	if ret == True:
		#frame = cv.flip(frame,0)

		out.write(frame)
		#frame = cv.resize(frame,(128,128),interpolation = cv.INTER_AREA)
		
		mean = np.mean(cv.cvtColor(frame,cv.COLOR_BGR2GRAY))
		

		#print(mean)
		
		if mean > meanSp+20:
			exposure -= 2
			cmd = "v4l2-ctl -c exposure_absolute=" + str(exposure)
			os.system(cmd)
		elif mean < meanSp-20:
			exposure += 2
			cmd = "v4l2-ctl -c exposure_absolute=" + str(exposure)
			os.system(cmd)
		
		cv.imshow('Frame',cv.resize(frame,(128,128)))
	

		if cv.waitKey(1) & 0xFF == ord('q'): 
			break

	else:
		break

	end = time.time()
	sys.stdout.write("Elapsed time: %.3f s   \r" % (end-start))
	sys.stdout.flush()


cap.release()
#out.release()
cv.destroyAllWindows()